using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Collections;
using System.Linq;

namespace NanoMod
{
    public class NanoMod
    {
        public static void Main()
        {
            CategoryBuilder.Create("Zuccians Nanomachines", "babobech", ModAPI.LoadSprite("logo_category.png"));
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Man",
                    DescriptionOverride = "the one and only \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("im.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("ironman.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironmandamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("headglow.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("upperglow.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 0.8f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hulkuster",
                    DescriptionOverride = "big boy \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("hbt.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = true;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("hulkbuster.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironmandamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("hbhead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("hbupper.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 0.8f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Man Model 42",
                    DescriptionOverride = "looks cool \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("m4.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("m42.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironmandamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("42h.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("42u.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(1f, 0.3f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(0.3f, 0.4f, 0.5f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Knight",
                    DescriptionOverride = "idk who this is but he looked cool \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("ik.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("ironknight.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironmandamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("kglow.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(1f, 0.3f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Man Newer Fantastic Four",
                    DescriptionOverride = "same with him \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("f.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("newf4.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("newf4damaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("f4.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(0f, 0.6f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Man Mark II",
                    DescriptionOverride = "grey \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("ma.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("m2.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("m2damaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("headglow.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("upperglow.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 0.8f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1f, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Stealth Suit",
                    DescriptionOverride = "sneaky \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("ss.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("stealth.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("stealthdamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("shead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("sup.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 0.8f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(0f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1f, 1f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Leigon",
                    DescriptionOverride = "evil or something idk \n Activate arms to charge Repulsor, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("il.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("ironleigon.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironleigondamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("lglow.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("lup.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = true;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 0.8f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage2Color = new Color(0f, 0f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().Stage3Color = new Color(1, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = false;
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "War Machine",
                    DescriptionOverride = "guns \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("wm.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("warmachine.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("warmachinedamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("whead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("wupper.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("gun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "War Machine Hulkbuster",
                    DescriptionOverride = "bigger guns \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("wmh.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = true;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("wmhulkbuster.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("warmachinedamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("wbhbhead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("wbhbupper.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 0f, 0f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("hbgun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Patriot Hulkbuster",
                    DescriptionOverride = "american \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("iph.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = true;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("iphulkbuster.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("warmachinedamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("hbhead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("hbupper.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 1f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("iphbgun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Moose Hulkbuster",
                    DescriptionOverride = "I LOVE CANADA!!! \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("hc.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = true;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("cphulkbuster.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("warmachinedamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("hbhead.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("hbupper.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 0f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("cphbgun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Patriot",
                    DescriptionOverride = "american \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("ip.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("ironpatriot.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("ironpatriotdamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("pglow.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("pstar.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(0f, 1f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("pgun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Iron Moose",
                    DescriptionOverride = "I LOVE CANADA!! \n Activate arms to shoot gun, activate chest to charge Unibeam, toggle foot to activate boosters and right click foot to customize boosters.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Nanomachines"),
                    ThumbnailOverride = ModAPI.LoadSprite("cd.png"),
                    AfterSpawn = (Instance) =>
                    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("test.png");
        Instance.AddComponent<BlobBuilder>();
        Instance.GetComponent<BlobBuilder>().HulkBuster = false;
        Instance.GetComponent<BlobBuilder>().Suit = ModAPI.LoadTexture("CANADA.png");
        Instance.GetComponent<BlobBuilder>().DSuit = ModAPI.LoadTexture("CANADAdamaged.png");
        Instance.GetComponent<BlobBuilder>().glow = ModAPI.LoadSprite("pglow.png");
        Instance.GetComponent<BlobBuilder>().glow2 = ModAPI.LoadSprite("leaf.png");
        Instance.GetComponent<BlobBuilder>().DoRepulsors = false;
        Instance.GetComponent<BlobBuilder>().StartColor = new Color(1f, 0f, 1f, 0.5f);
        Instance.GetComponent<BlobBuilder>().DoFlying = true;
        Instance.GetComponent<BlobBuilder>().DoGunsPewPew = true;
        Instance.GetComponent<BlobBuilder>().gun = ModAPI.LoadSprite("cgun.png");
        Instance.GetComponent<BlobBuilder>().DoUnibeam = true;
        Instance.FixColliders(); 
  }
}
);
        }
    }
    public class anim : MonoBehaviour
    {
        private Material material;
        public SpriteRenderer renderer;
        public LimbBehaviour limb;
        public float t;
        public Texture2D OgSkin = null;
        public Texture2D OgBones = null;
        public Texture2D OgFlesh = null;
        public bool rev;

        public void Start()
        {
                        renderer = this.gameObject.GetComponent<SpriteRenderer>();
                        limb = this.gameObject.GetComponent<LimbBehaviour>();
                        if ((UnityEngine.Object) limb.Person.ChosenMaterial != (UnityEngine.Object) null)
                        renderer.material = limb.Person.ChosenMaterial;
                        material = renderer.material;
                        StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
            t = 1f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.95f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.9f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.85f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.8f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.75f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.7f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.65f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.6f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.55f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.5f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.45f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.4f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.35f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.3f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.25f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.2f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.15f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.15f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.05f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            if (rev)
            {
                this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().SetBodyTextures(OgSkin, OgFlesh, OgBones);
            }
            Destroy(this.gameObject.GetComponent<anim>());
        }
    }
public class BlobBuilder : MonoBehaviour
{

        public Texture2D OgSkin = null;
        public Texture2D OgBones = null;
        public Texture2D OgFlesh = null;
        public Texture2D Suit;
        public Texture2D DSuit;
        public bool DoGunsPewPew;
        public bool HulkBuster;
        public Sprite glow;
        public Sprite glow2;
        public bool DoRepulsors;
        public bool DoFlying;
        public bool DoUnibeam;
        AudioClip Repulsor = ModAPI.LoadSound("lock.wav");  
        AudioClip UNIBEAM = ModAPI.LoadSound("UNIBEAM.wav");  
        public Color StartColor;
        public Color Stage2Color;
        public Color Stage3Color;
        public string gunname;
        public Sprite gun;
        public Vector3 BeforeScale;

    public void OnCollisionEnter2D(Collision2D other)
        {
                    if(other.gameObject.name.Contains("UpperBody") & !other.gameObject.GetComponent<Host>()) //checks if the name of the object includes head aka just a head so boom and also checks if it has a Suit already
            {
        GameObject childObject2 = new GameObject("Glow7");
        childObject2.transform.SetParent(other.gameObject.transform);
        childObject2.transform.localPosition = new Vector3(0f, 0f);
        childObject2.transform.localScale = new Vector3(1f, 1f);
        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
        childSprite2.sprite = this.glow2;
        childSprite2.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite2.transform.position = other.transform.position;
        childSprite2.transform.rotation = other.transform.rotation;
        childSprite2.sortingLayerName = "Top";
        childSprite2.color = Color.white;
        childObject2.AddComponent<Flicker>();
OgSkin = other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.sprite.texture;
OgFlesh = (Texture2D)other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_FleshTex");
                        OgBones = (Texture2D)other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_BoneTex");
other.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(Suit, DSuit, OgSkin);
this.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
foreach (var Limbs in other.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           this.BeforeScale = Limbs.transform.root.localScale;
           Limbs.BaseStrength += 4.5f;
                  Limbs.Health *= 80f;
                  Limbs.InitialHealth *= 80f;
                  Limbs.ShotDamageMultiplier *= 0.1f;
                  Limbs.BreakingThreshold += 11f;
                  Limbs.RegenerationSpeed += 30f;
                  Limbs.Vitality *= 50f;
                  Limbs.ImpactPainMultiplier *= 0.1f;
                  Limbs.IsLethalToBreak = false;
            Limbs.gameObject.AddComponent<anim>();
            Limbs.gameObject.GetComponent<anim>().OgSkin = OgSkin;
           Limbs.gameObject.GetComponent<anim>().OgFlesh = OgFlesh;
          Limbs.gameObject.GetComponent<anim>().OgBones = OgBones;
          Limbs.gameObject.AddComponent<Host>();
          Limbs.gameObject.GetComponent<Host>().BeforeScale = this.BeforeScale;
          Limbs.gameObject.GetComponent<Host>().OgSkin = this.OgSkin;
          Limbs.gameObject.GetComponent<Host>().DSuit = this.DSuit;
          //Limbs.IsAndroid = true;
                  Limbs.GetComponent<Host>().buh = childObject2;
          Limbs.gameObject.GetComponent<Host>().Suit = this.Suit;
          Limbs.gameObject.GetComponent<Host>().OgFlesh = this.OgFlesh;
          Limbs.gameObject.GetComponent<Host>().OgBones = this.OgBones;
          Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
          
if(Limbs.gameObject.name.Contains("UpperBody") && this.DoUnibeam) 
            {
                Limbs.gameObject.AddComponent<Unibeam>();
                Limbs.gameObject.GetComponent<Unibeam>().Enabled = false;
                Limbs.gameObject.GetComponent<Unibeam>().StartColor = this.StartColor;
AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
                                    audio.spatialBlend = 1;
					Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
					{
						                                    audio.PlayOneShot(UNIBEAM);
					};
            }

            if (this.HulkBuster)
            {
                Limbs.gameObject.GetComponent<Host>().HulkBuster = true;
                Limbs.transform.root.localScale *= 1.03f;
                if(Limbs.gameObject.name.Contains("Head")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1.1f);
            }
            if(Limbs.gameObject.name.Contains("UpperBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.7f, 1.2f);
                Limbs.gameObject.GetComponent<Unibeam>().HulkBuster = true;
            }
            if(Limbs.gameObject.name.Contains("MiddleBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.5f, 1f);
            }
            if(Limbs.gameObject.name.Contains("LowerBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("UpperLeg")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.5f, 1f);
            }
            if(Limbs.gameObject.name.Contains("LowerLeg")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("Foot")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("UpperArm")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.7f, 1.1f);
            }
            if(Limbs.gameObject.name.Contains("LowerArm")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.2f, 1f);
            }
            }

          if(Limbs.gameObject.name.Contains("Head")) 
            {
               GameObject childObject = new GameObject("Glow2");
        childObject.transform.SetParent(Limbs.gameObject.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = this.glow;
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.transform.position = Limbs.transform.position;
        childSprite.transform.rotation = Limbs.transform.rotation;
        childSprite.sortingLayerName = "Top";
        childSprite.color = Color.white;
        childObject.AddComponent<Flicker>();
        Limbs.GetComponent<Host>().flicker = childObject;
            }

            if(Limbs.gameObject.name.Contains("Foot") && this.DoFlying) 
            {
         Limbs.gameObject.AddComponent<Flying>();
         var trailrenderer = Limbs.gameObject.AddComponent<TrailRenderer>();
                            trailrenderer.startWidth = 0.05f;
                            trailrenderer.endWidth = 0.4f;
                            trailrenderer.time = 1f;
                            trailrenderer.startColor = Color.clear;
                            trailrenderer.endColor = Color.clear;
                            trailrenderer.material = ModAPI.FindMaterial("VeryBright");
                            trailrenderer.sortingOrder = Limbs.GetComponent<SpriteRenderer>().sortingOrder = 1;
            }

            if(Limbs.gameObject.GetComponent<GripBehaviour>() && this.DoGunsPewPew)
            {
Limbs.gameObject.GetComponent<Host>().gun = gun;
                if(Limbs.gameObject.name.Contains("Front"))
            {
GameObject Item3 = GameObject.Instantiate(ModAPI.FindSpawnable("G1 Submachine Gun").Prefab);
                Item3.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Item3.layer = 10;
                Item3.GetComponent<SpriteRenderer>().color = Color.white;
Item3.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightless();
Item3.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
Item3.gameObject.GetComponent<SpriteRenderer>().sprite = gun;
if (Limbs.transform.root.transform.localScale.x < 0)
                            {
                            Item3.transform.localScale = new Vector3(Item3.transform.localScale.x, -Item3.transform.localScale.y, Item3.transform.localScale.z);
                            }
                    else
                    {
                        //ModAPI.Notify("huh");
                        Item3.transform.localScale = new Vector3(Item3.transform.localScale.x, Item3.transform.localScale.y, Item3.transform.localScale.z);
                    }
Limbs.gameObject.GetComponent<Host>().Pew = Item3;
Item3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item3.transform.SetParent(Limbs.transform);
                            Item3.FixColliders();
                            Item3.layer = 10;
            }
            else
            {
GameObject Item4 = GameObject.Instantiate(ModAPI.FindSpawnable("G1 Submachine Gun").Prefab);
                Item4.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Item4.layer = 10;
                Item4.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                Item4.GetComponent<SpriteRenderer>().color = Color.white;
Item4.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightless();
Item4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
Item4.gameObject.GetComponent<SpriteRenderer>().sprite = gun;
Limbs.gameObject.GetComponent<Host>().Pew2 = Item4;
if (Limbs.transform.root.transform.localScale.x < 0)
                            {
                            Item4.transform.localScale = new Vector3(Item4.transform.localScale.x, -Item4.transform.localScale.y, Item4.transform.localScale.z);
                            }
                    else
                    {
                        //ModAPI.Notify("huh");
                        Item4.transform.localScale = new Vector3(Item4.transform.localScale.x, Item4.transform.localScale.y, Item4.transform.localScale.z);
                    }
                        Item4.transform.SetParent(Limbs.transform);
                            Item4.FixColliders();
                            Item4.layer = 10;

            }
            }

            if(Limbs.gameObject.GetComponent<GripBehaviour>() && this.DoRepulsors)
            {
                Limbs.gameObject.AddComponent<Repulsors>();
                Limbs.gameObject.GetComponent<Repulsors>().Enabled = false;
                Limbs.gameObject.GetComponent<Repulsors>().StartColor = this.StartColor;
                Limbs.gameObject.GetComponent<Repulsors>().Stage2Color = this.Stage2Color;
                Limbs.gameObject.GetComponent<Repulsors>().Stage3Color = this.Stage3Color;
                if (this.HulkBuster)
                {
                                    Limbs.gameObject.GetComponent<Repulsors>().HulkBuster = true;
                }
AudioSource audio = Limbs.gameObject.AddComponent<AudioSource>();
                                    audio.spatialBlend = 1;
					Limbs.gameObject.AddComponent<UseEventTrigger>().Action = () =>
					{
						                                    audio.PlayOneShot(Repulsor);
					};
            }
}
            }
        }
        public class Flicker : MonoBehaviour
        {
            public bool doFlicker = true;

            public void Start()
            {

            }
            
            public void Update()
            {
                if (doFlicker)
                {
                float randomNumber = UnityEngine.Random.Range(0.2f, 0.37f);
                this.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, randomNumber);
                }
        }
        }
        public class Flying : MonoBehaviour
        {
            public bool Enabled = true;
            public int Thrust = 8;
            public bool bhugh;
            public float Height = 9f;

            public void Start()
            {
                this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("enbb", (Func<string>) (() => !this.bhugh ? "Disable Thrusters" : "Enable Thrusters"), "Toggle Thrusters", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    if (!bhugh)
                    {
                        bhugh = true;
                        Enabled = true;
                    }
                    else
                    {
                        bhugh = false;
                        Enabled = false;
                    }
                })
            }));
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("settime", "Set Thruster Time", "Set Thruster Time", new UnityAction[1]
            {
            (UnityAction) (() =>
        {
            DialogBox dialog = (DialogBox) null;
            dialog = DialogBoxManager.TextEntry("Change the time that the thrusters are in the air, the default time is 8. ", "8", new DialogButton("Apply", true, new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if (dialog.EnteredText != "")
                    {;
                        var text = dialog.EnteredText.Split(","[0]);
                        ModAPI.Notify("Thrust time is now " + dialog.EnteredText);
                        this.Thrust = int.Parse(text[0]);

                    }
                    else
                        ModAPI.Notify("You didn't input anything.");
                })
            }),
            new DialogButton("Cancel", true, new UnityAction[1]
            {
                    (UnityAction) (() => dialog.Close())
            }));
                })
                }));
                this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("sethigh", "Set Thruster Height", "Set Thruster Height", new UnityAction[1]
            {
            (UnityAction) (() =>
        {
            DialogBox dialog = (DialogBox) null;
            dialog = DialogBoxManager.TextEntry("Change how high the thrusters go off launch. Default is 9", "9", new DialogButton("Apply", true, new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    if (dialog.EnteredText != "")
                    {;
                        var text = dialog.EnteredText.Split(","[0]);
                        ModAPI.Notify("Thrust height is now " + dialog.EnteredText);
                        this.Height = float.Parse(text[0]);

                    }
                    else
                        ModAPI.Notify("You didn't input anything.");
                })
            }),
            new DialogButton("Cancel", true, new UnityAction[1]
            {
                    (UnityAction) (() => dialog.Close())
            }));
                })
                }));
            }

            public void Use()
            {
                if (!Enabled)
                {

                }
                else
                {
                this.gameObject.GetComponent<TrailRenderer>().startColor = new Color32(255, 150, 0, 100);
                this.gameObject.GetComponent<TrailRenderer>().endColor = new Color32(255, 120, 0, 10);
                ModAPI.CreateParticleEffect("BlasterImpact", this.transform.position);

                foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           float vel  = Limbs.gameObject.GetComponent<Rigidbody2D>().velocity.x;
                Limbs.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(vel, Height); 
                Limbs.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 2f);
                StartCoroutine(RRRRRRR());
       }
                }
            }


           public IEnumerator RRRRRRR() 
 {
     for (int i = 0; i < Thrust; i++)
        {
            this.gameObject.GetComponent<TrailRenderer>().startColor = new Color32(255, 150, 0, 100);
                                    yield return new WaitForSeconds(0.1f);
            this.gameObject.GetComponent<TrailRenderer>().startColor = Color.clear;
            this.gameObject.GetComponent<TrailRenderer>().endColor = Color.clear;
            foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           Limbs.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 2f);
float vel  = Limbs.gameObject.GetComponent<Rigidbody2D>().velocity.x;
                Limbs.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(vel, 1f); 
       }
        }
 }
        }
        public class Repulsors : MonoBehaviour
        {
            public bool Enabled = false;
            public bool Using = true;
            public bool HulkBuster;
            public bool bhuhb;
            public float speed2 = 1f;
            public float speed = 28f;
            public GameObject qa;
            public Color StartColor;
            public Color Stage2Color;
            public Color Stage3Color;

            public void Start()
            {
                this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("enb", (Func<string>) (() => !this.bhuhb ? "Disable Repulsors" : "Enable Repulsors"), "Toggle Repulsors", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    if (!bhuhb)
                    {
                        bhuhb = true;
                        Enabled = true;
                        this.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                    }
                    else
                    {
                        bhuhb = false;
                        Enabled = false;
                        this.gameObject.GetComponent<UseEventTrigger>().enabled = true;
                    }
                })
            }));
            }


            public void Update()
            {
                if (this.qa != null)
                {
                if(!Using)
                {
                    if (this.speed > 80f)
                    {
                                         qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Stage3Color;
                 qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier = 1.2f;
                 qa.GetComponent<BlasterboltBehaviour>().Trail.time = 0.05f;
                 qa.GetComponent<BlasterboltBehaviour>().CreateExplosion = true;
                 qa.GetComponent<BlasterboltBehaviour>().SpawnExplosionEffect = true;
                 qa.GetComponent<BlasterboltBehaviour>().ExplosionDamage = 170f;
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed * 3f;
                  qa.GetComponent<BlasterboltBehaviour>().Speed = 125f;
                    }
                    else
                    {
                        if (this.speed > 40f)
                    {
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Stage2Color;
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed * 1.2f;
                  qa.GetComponent<BlasterboltBehaviour>().Speed = this.speed * 1.2f;
                    }
                    else
                    {

                  qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = StartColor;
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed;
                  qa.GetComponent<BlasterboltBehaviour>().Speed = this.speed;
                    }
                }
                }
                else
                {

                }
                }
            }

            public void UseContinuous()
		{
            if (!Enabled)
                {
            this.speed2 = this.speed2 - 0.01f;
            this.speed = this.speed + 0.3f;
            qa.transform.position = this.gameObject.transform.position;
                                    qa.transform.eulerAngles = this.gameObject.transform.eulerAngles;
                                    qa.transform.eulerAngles += new Vector3(0, 0, 270);
                                    if (this.HulkBuster)
                  {
                      qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier = 1.2f;
                  }
            //string str1 = this.speed.ToString();
            //ModAPI.Notify(str1);
             qa.GetComponent<BlasterboltBehaviour>().Speed = 0f;
             var e = ModAPI.CreateParticleEffect("Vapor", this.transform.position);
                e.GetComponent<ParticleSystem>().startColor = StartColor;
              this.Using = false;
                }
        }

            public void Use()
            {
                if (!Enabled)
                {
                    this.speed2 = 1f;
                    this.speed = 22f;
                    this.Using = true;
                this.qa = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().damage = 10f;
                                    qa.GetComponent<BlasterboltBehaviour>().Speed = 28f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.1f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.time = 0.2f;
                                    
                                    qa.transform.position = this.gameObject.transform.position;
                                    qa.transform.eulerAngles = this.gameObject.transform.eulerAngles;
                                    qa.transform.eulerAngles += new Vector3(0, 0, 270);
                }
            }
        }
         public class Unibeam : MonoBehaviour
        {
            public bool Enabled = false;
            public bool Using = true;
            public bool bhuhb;
            public bool HulkBuster;
            public float speed2 = 1f;
            public float speed = 28f;
            public Color StartColor;
            public GameObject qa;

            public void Start()
            {
                this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("enb", (Func<string>) (() => !this.bhuhb ? "Disable Unibeam" : "Enable Unibeam"), "Toggle Unibeam", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    if (!bhuhb)
                    {
                        bhuhb = true;
                        Enabled = true;
                        this.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                    }
                    else
                    {
                        bhuhb = false;
                        Enabled = false;
                        this.gameObject.GetComponent<UseEventTrigger>().enabled = true;
                    }
                })
            }));
            }


            public void Update()
            {
                if (this.qa != null)
                {
                if(!Using)
                {
                    if (this.speed > 90f)
                    {
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(1, 0f, 0f, 0.5f);
                 qa.GetComponent<BlasterboltBehaviour>().CreateExplosion = true;
                 qa.GetComponent<BlasterboltBehaviour>().SpawnExplosionEffect = true;
                 qa.GetComponent<BlasterboltBehaviour>().ExplosionDamage = 270f;
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed * 4f;
                    }
                    else
                    {
                        if (this.speed > 50f)
                    {
                        qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0.6f, 0f, 1f, 0.5f);
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed * 2f;
                    }
                    else
                    {

                  qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = StartColor;
                  qa.GetComponent<BlasterboltBehaviour>().damage = this.speed;
                    }
                }
                }
                else
                {

                }
                }
            }

            public void UseContinuous()
		{
            if (!Enabled)
                {
            this.speed2 = this.speed2 - 0.01f;
            this.speed = this.speed + 0.3f;
            qa.transform.position = this.gameObject.transform.position;
            qa.transform.eulerAngles = this.gameObject.transform.eulerAngles;
            if (this.transform.root.transform.localScale.x < 0)
                            {
                             qa.transform.eulerAngles += new Vector3(0, 0, 180);
                            }
                    else
                    {
                        //ModAPI.Notify("huh");
                        qa.transform.eulerAngles += new Vector3(0, 0, 0);
                    }
            if (this.transform.position.x < 0) //left
                    {

                    }
                    else
                    {

                    }
                    if (this.HulkBuster)
                  {
                      qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier = 1f;
                  }
            //string str1 = this.speed.ToString();
            //ModAPI.Notify(str1);
             var e = ModAPI.CreateParticleEffect("Vapor", this.transform.position);
                e.GetComponent<ParticleSystem>().startColor = StartColor;
              this.Using = false;
                }
        }

            public void Use()
            {
                if (!Enabled)
                {
                    this.speed2 = 1f;
                    this.speed = 33f;
                    this.Using = true;
                this.qa = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().damage = 10f;
                                    qa.GetComponent<BlasterboltBehaviour>().Speed = 28f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.3f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.time = 0.4f;
                                    
                                    qa.transform.position = this.gameObject.transform.position;
                                    qa.transform.eulerAngles = this.gameObject.transform.eulerAngles;
                    if (this.transform.position.x < 0) //left
                    {
                        qa.transform.eulerAngles += new Vector3(0, 0, 0);
                    }
                    else
                    {
                         qa.transform.eulerAngles += new Vector3(0, 0, 180);
                    }
                }
            }
        }
public class Host : MonoBehaviour
{

        public Texture2D OgSkin;
        public Texture2D OgFlesh;
        public Texture2D OgBones;
        public Texture2D Suit;
        public GameObject flicker;
        public bool HulkBuster;
        public GameObject Pew;
        public GameObject Pew2;
        public GameObject buh;
        public Texture2D DSuit;
        public bool HardenNShit = false;
        public Vector3 BeforeScale;
        public Sprite gun;
        public bool ngsd;

        public void Update()
        {
            if(HardenNShit)
            {
                   foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                   {

                   if(Limbs.gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 0)
                   {

          Limbs.gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount = (ushort)0;
          Revive();
                   }
                   }
            }

                 this.Pew = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.GetComponent<Host>().Pew;
                 this.Pew2 = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.GetComponent<Host>().Pew2;
            if (this.Pew != null && this.Pew2 !=null)
                {
                    this.Pew.transform.position = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position;
                    this.Pew.transform.rotation = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.rotation;
                    this.Pew.transform.eulerAngles += new Vector3(0, 0, 270);
                    this.Pew2.transform.position = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
                    this.Pew2.transform.rotation = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation;
                    this.Pew2.transform.eulerAngles += new Vector3(0, 0, 270);
                }
                else
                {

                }
        }

    public void Start()
    {
        foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          this.flicker = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.GetComponent<Host>().flicker;
          this.Pew = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.GetComponent<Host>().Pew;
                 this.Pew2 = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.GetComponent<Host>().Pew2;
       }
        this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("sum", "Activate Suit", "Activate Suit", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          Revive();
          if (HulkBuster)
          {
                                                         Limbs.transform.root.localScale *= 1.03f;
          }
       }
                })
            }));
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("de", "Deactivate Suit", "Deactivate Suit", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
        foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
         Die();
       }
                })
            }));
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("re", "Remove Suit", "Remove Suit", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
        
  foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
         Remove();
       }
                })
            }));
            if (this.Pew != null && this.Pew2 != null)
                {
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("gung", (Func<string>) (() => !this.ngsd ? "Disable Guns" : "Enable Guns"), "ToggleGuns", new UnityAction[1]
            {
                (UnityAction) (() => 
                {
                    if (!ngsd)
                    {
                        ngsd = true;
                Pew.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = true;
                Pew2.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = true;
                Pew.layer = 0;
                Pew2.layer = 0;
                Pew2.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
                Pew.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
                    }
                    else
                    {
                        ngsd = false;
                        Pew.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Pew2.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Pew.layer = 10;
                Pew2.layer = 10;
                Pew2.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
                Pew.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
                    }
                })
            }));
                }
    }
    public void Remove()
    {
this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(OgSkin, OgFlesh, OgBones);
foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          Limbs.gameObject.AddComponent<anim>();
          Limbs.gameObject.GetComponent<anim>().rev = true;
            Limbs.gameObject.GetComponent<anim>().OgSkin = OgSkin;
           Limbs.gameObject.GetComponent<anim>().OgFlesh = OgFlesh;
          Limbs.gameObject.GetComponent<anim>().OgBones = OgBones;
        this.flicker.GetComponent<Flicker>().doFlicker = false;
        this.flicker.GetComponent<SpriteRenderer>().color = Color.clear;
        this.buh.GetComponent<SpriteRenderer>().color = Color.clear;
        this.buh.GetComponent<Flicker>().doFlicker = false;
        var mama = Limbs.gameObject.GetComponent<Host>();
        if(Limbs.gameObject.name.Contains("Foot")) 
            {
           var hm = Limbs.gameObject.GetComponent<Flying>();
           Destroy(hm);
            }   
            if(Limbs.gameObject.name.Contains("UpperBody")) 
            {
                if (Limbs.gameObject.GetComponent<Unibeam>())
                {
           var ghuhg = Limbs.gameObject.GetComponent<Unibeam>();
        Destroy(ghuhg);
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                }
            }  
            if (this.HulkBuster)
            {
                Limbs.transform.root.localScale = BeforeScale;
                Limbs.gameObject.transform.localScale = new Vector3(1f, 1f);
            }
        if (Limbs.gameObject.GetComponent<GripBehaviour>())
        {
            if (Limbs.gameObject.GetComponent<Repulsors>())
                {
        var ghuhg = Limbs.gameObject.GetComponent<Repulsors>();
        Destroy(ghuhg);
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                }
                if (this.Pew != null && this.Pew2 != null)
                {
                Destroy(Pew);
                Destroy(Pew2);
                }
        }
        this.HardenNShit = false;
        Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
        Destroy(mama);
       }
    }
    public void Die()
    {
this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(OgSkin, DSuit, Suit);
foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
            Limbs.gameObject.AddComponent<anim>();
          Limbs.gameObject.GetComponent<anim>().rev = true;
            Limbs.gameObject.GetComponent<anim>().OgSkin = OgSkin;
           Limbs.gameObject.GetComponent<anim>().OgFlesh = OgFlesh;
          Limbs.gameObject.GetComponent<anim>().OgBones = OgBones;
        this.flicker.GetComponent<Flicker>().doFlicker = false;
        this.flicker.GetComponent<SpriteRenderer>().color = Color.clear;
        this.buh.GetComponent<SpriteRenderer>().color = Color.clear;
        this.buh.GetComponent<Flicker>().doFlicker = false;
        if(Limbs.gameObject.name.Contains("Foot")) 
            {
            Limbs.gameObject.GetComponent<Flying>().Enabled = false;
            }   
             if(Limbs.gameObject.name.Contains("UpperBody")) 
            {
                if (Limbs.gameObject.GetComponent<Unibeam>())
                {
           Limbs.gameObject.GetComponent<Unibeam>().Enabled = true;
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                }
            }  
                        if (this.HulkBuster)
            {
                Limbs.transform.root.localScale = BeforeScale;
                Limbs.gameObject.transform.localScale = new Vector3(1f, 1f);
            }
        if (Limbs.gameObject.GetComponent<GripBehaviour>())
        {
            if (Limbs.gameObject.GetComponent<Repulsors>())
                {
        Limbs.gameObject.GetComponent<Repulsors>().Enabled = true;
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = false;
                }
                if (this.Pew != null && this.Pew2 != null)
                {
                Pew.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = true;
                Pew2.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = true;
                Pew.layer = 0;
                Pew2.layer = 0;
                Pew2.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
                Pew.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
                }
        }
        this.HardenNShit = true;
        Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
       }
    }
    public void Revive()
    {
this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(Suit, DSuit, OgSkin);
foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          Limbs.gameObject.AddComponent<anim>();
        this.flicker.GetComponent<Flicker>().doFlicker = true;
        this.buh.GetComponent<Flicker>().doFlicker = true;
                if(Limbs.gameObject.name.Contains("Foot")) 
            {
            Limbs.gameObject.GetComponent<Flying>().Enabled = true;
            }   
            if(Limbs.gameObject.name.Contains("UpperBody")) 
            {
                if (Limbs.gameObject.GetComponent<Unibeam>())
                {
           Limbs.gameObject.GetComponent<Unibeam>().Enabled = false;
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = true;
                }
            }  
            if (this.HulkBuster)
            {
                if(Limbs.gameObject.name.Contains("Head")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1.1f);
            }
            if(Limbs.gameObject.name.Contains("UpperBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.7f, 1.2f);
                Limbs.gameObject.GetComponent<Unibeam>().HulkBuster = true;
            }
            if(Limbs.gameObject.name.Contains("MiddleBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.5f, 1f);
            }
            if(Limbs.gameObject.name.Contains("LowerBody")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("UpperLeg")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.5f, 1f);
            }
            if(Limbs.gameObject.name.Contains("LowerLeg")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("Foot")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.3f, 1f);
            }
            if(Limbs.gameObject.name.Contains("UpperArm")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.7f, 1.1f);
            }
            if(Limbs.gameObject.name.Contains("LowerArm")) 
            {
                Limbs.gameObject.transform.localScale = new Vector3(1.2f, 1f);
            }
            if(Limbs.gameObject.GetComponent<GripBehaviour>())
            {
                if (Limbs.gameObject.GetComponent<Repulsors>())
                {
                Limbs.gameObject.GetComponent<Repulsors>().HulkBuster = true;
                }
            }
            }
                if (Limbs.gameObject.GetComponent<GripBehaviour>())
        {
            if (Limbs.gameObject.GetComponent<Repulsors>())
                {
        Limbs.gameObject.GetComponent<Repulsors>().Enabled = false;
        Limbs.gameObject.GetComponent<UseEventTrigger>().enabled = true;
                }
                if (this.Pew != null && this.Pew2 != null)
                {
                Pew.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Pew2.gameObject.GetComponent<FirearmBehaviour>().IgnoreUse = false;
                Pew.layer = 10;
                Pew2.layer = 10;
                Pew2.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
                Pew.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
                }
        }
        this.HardenNShit = false;
        Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
       }
    }
}
}
}